﻿Imports System.Windows.Forms
Imports System.IO
Imports fishfact2.Cybele.Thinfinity

Public Class FormMain
    Private mVirtualUI As VirtualUI
    Private mRemoteDB As IJSObject = Nothing

    Public Sub New()
        InitializeComponent()
        AppDomain.CurrentDomain.SetData("DataDirectory", Path.GetFullPath("..\\..\\..\\..\\data"))

        mVirtualUI = New VirtualUI()
        mVirtualUI.Start()
    End Sub

    Private Sub FormMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.BIOLIFETableAdapter.Fill(Me.DbdemosDataSet.BIOLIFE)
    End Sub

    Public ReadOnly Property RemoteDB() As IJSObject
        Get
            If mRemoteDB Is Nothing Then
                ' Creates the "db" JSObject
                mRemoteDB = New JSObject("db")
                ' Creates the "CATEGORY" property.
                mRemoteDB.Properties.Add("CATEGORY")
                ' Applies the object model and sends it to the web browser
                mRemoteDB.ApplyModel()
            End If
            Return mRemoteDB
        End Get
    End Property

    Private Sub BIOLIFEBindingSource_PositionChanged(sender As Object, e As EventArgs) Handles BIOLIFEBindingSource.PositionChanged
        ' Assigns the value of the dataset field
        RemoteDB.Properties("CATEGORY").AsString = DbdemosDataSet.BIOLIFE.Rows(BIOLIFEBindingSource.Position)("CATEGORY").ToString()
    End Sub
End Class
